// ============================================================================
//
// CBP_VderPol.c
// Hexapod CPG	For CBP_Hexapod_2
// CBP 03-12-20
// 15-03-21 RELEASE
//
// ============================================================================

#include <math.h>
#include <stdio.h>
#include "CBP_VderPol.h"

// Parameters
double alpha, mu, omega, tau, k;
double thresh, drive;

void setParams(double alpha_,  double mu_, double omega_, double tau_, double k_, double thresh_) {
    alpha = alpha_;
	mu = mu_;
	omega = omega_;
	tau = tau_;
	k = k_;
	thresh = thresh_;	
}

// Naming neurons --------------------------------------------------------------
// Neuron	ODE index
// LF		0	
// LM		4
// LR		7
// RF		10		
// RM		13		
// RR		16

void vdPol3(double t, double y[], double dydt[]) {
double r,tau1,k1;
// get angles into range
/*
while(y[0]  > 2*M_PI) y[0]  -= 2*M_PI;
while(y[0]  < -2*M_PI) y[0]  += 2*M_PI;
while(y[4]  > 2*M_PI) y[4]  -= 2*M_PI;
while(y[4]  < -2*M_PI) y[4]  += 2*M_PI;
while(y[7]  > 2*M_PI) y[7]  -= 2*M_PI;
while(y[7]  < -2*M_PI) y[7]  += 2*M_PI;
while(y[10] > 2*M_PI) y[10] -= 2*M_PI;
while(y[10] < -2*M_PI) y[10] += 2*M_PI;
while(y[13] > 2*M_PI) y[13] -= 2*M_PI;
while(y[13] < -2*M_PI) y[13] += 2*M_PI;
while(y[16] > 2*M_PI) y[16] -= 2*M_PI;
while(y[16] < -2*M_PI) y[16] += 2*M_PI;
*/
// ------------ calculate r's ----------------------------------------------------
r= sqrt(y[0]*y[0] + y[1]*y[1]);
// -----------------------------------------------------------------------------
//omegaST = (1 - beta)*omegaSW/beta;
// -----------------------------------------------------------------------------
// Oscillator
//omega = omegaST/(exp(-a*y[1]) + 1) + omegaSW/(exp(a*y[1]) + 1);
// Oscillator driving the front left leg
dydt[0] = 0;
dydt[1] = 0;

// Chain of phase shifts
// Left middle leg
dydt[2] = 0;
dydt[3] = 0;
dydt[4] = 0;

// left rear leg
dydt[5] = 0;
dydt[6] = 0;
dydt[7] = 0;

// This will produce 180 degree phase shifts

// Right front leg
tau1 = tan(M_PI/3)/omega;
k1 = sqrt(tau1*tau1*omega*omega + 1);

dydt[8]  = 0;
dydt[9]  = 0;
dydt[10] = 0;

// Right middle leg
dydt[11] = 0;
dydt[12] = 0;
dydt[13] = 0;

// Right rear leg
dydt[14] = 0;
dydt[15] = 0;
dydt[16] = 0;

// Additional neurons to provide swing - stance drive signal
if( y[0] > thresh) drive = 1; else drive = 0;
dydt[17] = (-y[17] + 5.0*drive)/tau1;



  return;
}

