// ============================================================================
//
// CBP_Quadruped_2_rhs.c
//
// CBP 03-03-21
// Quadruped rhs.
// 15-03-21 RELEASE
//
// ============================================================================

#include <math.h>
#include <stdio.h>
#include "CBP_Quadruped_2_rhs.h"

double a,b,mu,omega;
double g, r0;
double theta12, theta23, theta34;

void setParams(double g_, double r0_, double omega_, double t12, double t23, double t34){
  g = g_;
  r0 = r0_;
  omega = omega_;
  theta12 = t12;
  theta23 = t23;
  theta34 = t34;
}

// Oscillator labelling
// Left Front:	y[0], y[1]
// Left Hind:	y[2], y[3], y[4]
// Right Hind:	y[5], y[6], y[7]
// Right Front:	y[8], y[9], y[10]

void rhs_2(double t, double y[], double dydt[]) {
  double r;
  double phase,tau,k;
  
  // possibly normalize the phases ------------------------------
  // This does help the 'delinquent' gaits e.g. rotary gallop.
  for(int i=0;i<14;i++) {
    while(y[i] >  M_PI) y[i] -= 2*M_PI;
	while(y[i] < -M_PI) y[i] += 2*M_PI;
  }
  // Left Front oscillator --------------------------------------
  r = sqrt(y[0]*y[0] + y[1]*y[1]); 
  dydt[0] =  0;
  dydt[1] =  0;
  
  // Chain of phase shifts --------------------------------------
  // Left front to Left hind
  // Get phase and calc tau and k
  phase = theta12;


  dydt[2] = 0;
  dydt[3] = 0;
  dydt[4] = 0;  
  dydt[5] = 0;  
  
  // Left hind to Right hind
  // Get phase and calc tau and k;
  dydt[6] = 0;
  dydt[7] = 0;
  dydt[8] = 0;
  dydt[9] = 0;  
  
  // Right hind to Right front
  // Get phase and calc tau and k
  dydt[10]  = 0;
  dydt[11]  = 0;
  dydt[12]  = 0;
  dydt[13]  = 0;  
  
  return;
}


